/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.dialog;

/**
 * Editing interface for {@link ElementTreeSingleSelectDialog} and
 * {@link ElementTreeMultiSelectDialog}
 * 
 * @author mou
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 18119587EF4CCE8667EF38F2C34D6C76
 */
public interface IDialogEditSupport {

	/** Return the new element */
	public Object createElement(Object selected);

	/**
	 * Delete the element
	 * 
	 * @param selected
	 *            element to be deleted
	 * @return true if the element is deleted.
	 */
	public boolean deleteElement(Object selected);

	/** Edit the element */
	public void editElement(Object selected);

	/**
	 * Check if element can be created
	 * 
	 * @return true if a new element can be created, otherwise false
	 */
	public boolean canCreateElement(Object selected);

	/**
	 * Check if element can be deleted
	 * 
	 * @return true if the element can be deleted, otherwise false
	 */
	public boolean canDeleteElement(Object selected);

	/**
	 * Check if element can be edited
	 * 
	 * @return true if the element can be edited, otherwise false
	 */
	public boolean canEditElement(Object selected);
}