/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.utils;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.SWT;

/**
 * Utility methods for JFace {@link TableViewer}s.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: C0D33568CD83347695F9B10BB6883E7C
 */
public class TableViewerUtils {

	/**
	 * Creates a simple column in the table viewer.
	 * 
	 * @param viewer
	 *            the table viewer
	 * @param width
	 *            the column width
	 * @param title
	 *            the column title
	 * @param tooltip
	 *            the column tool tip
	 * @param labelProvider
	 *            the column's label provider
	 * @return the configured viewer column
	 */
	public static TableViewerColumn makeColumn(TableViewer viewer, int width,
			String title, String tooltip, ColumnLabelProvider labelProvider) {
		final TableViewerColumn column = new TableViewerColumn(viewer, SWT.LEFT);
		column.getColumn().setWidth(width);
		column.getColumn().setText(title);
		column.getColumn().setToolTipText(tooltip);
		column.setLabelProvider(labelProvider);
		return column;
	}
}
