/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.internal.actions;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory;
import org.fortiss.tooling.kernel.service.ICommandStackService;
import org.fortiss.tooling.kernel.ui.extension.base.EObjectActionBase;
import org.fortiss.tooling.kernel.ui.util.CopyPasteUtils;

/**
 * Action for pasting the current selection.
 * 
 * @author hummel
 * @author hoelzlf
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: D744CDA97D57CC13257501F7090F0002
 */
public class PasteAction extends EObjectActionBase<EObject> {

	/** Constructor. */
	public PasteAction() {
		super("Paste", PlatformUI.getWorkbench().getSharedImages()
				.getImageDescriptor(ISharedImages.IMG_TOOL_PASTE));
		setId(ActionFactory.PASTE.getId());
	}

	/** {@inheritDoc} */
	@Override
	public void run() {
		ICommandStackService.INSTANCE.runAsCommand(getTarget(), new Runnable() {
			@Override
			public void run() {
				CopyPasteUtils.pasteFromClipboard(getTarget(), null);
			}
		});
	}

	/** {@inheritDoc} */
	@Override
	protected boolean computeEnabled() {
		return CopyPasteUtils.canPasteInto(getTarget(), null);
	}
}
